

#ifndef SOURCEFS_H
#define SOURCEFS_H

#include <dirent.h>
#include <sys/stat.h>

/**
 * Initializes the source file handling.
 *
 * @param root_path The root of the source files folder.
 * @return 0 on success, -1 on failure.
 */
int source_init(const char *root_path);

/**
 * `stat()`, but for source files.
 *
 * @see `stat()`
 */
int source_stat(const char *restrict pathname, struct stat *restrict statbuf);

/**
 * `readdir()`, but for source files.
 *
 * @see `readdir(3)`
 */
struct dirent *source_readdir(DIR *dirp);

/**
 * `opendir()`, but for source files.
 *
 * @see `opendir()`
 */
DIR *source_opendir(const char *filename);

#endif // !SOURCEFS_H
